from flask import request, Response
from messaging.MessageSender import MessageSender
import json


def receive():
    body = request.json
    
    if isBlockchainTraceValid(body):
        
        # TODO remove workaround
        message_sender = MessageSender()
        message_sender.connect()
        message_sender.create_exchange('inhub', 'direct')

        message = {'type': 'blockchain-transaction', 'content': body}
        message_sender.send('inhub', json.dumps(message), 'trace-retrieval')

        message_sender.disconnect()

        return Response(status=201)
        
    return Response(status=400)

def isBlockchainTraceValid(trace) -> bool:
    return 'TransactionId' in trace \
        and 'Timestamp' in trace \
        and 'ApplicationType' in trace \
        and 'TransactionFrom' in trace \
        and 'TransactionFromLatLng' in trace \
        and 'TransactionTo' in trace \
        and 'TransactionToLatLng' in trace \
        and 'TransferredAsset' in trace \
        and 'ResourceIds' in trace \
        and 'ResourceMd5' in trace \
        and 'ResourceState' in trace \
        and 'Metadata' in trace
